Files
apfstests/tests/generic/015
T

115 lines
2.0 KiB
Bash
Raw Normal View History

#! /bin/bash
2018-06-09 11:35:42 +10:00
# SPDX-License-Identifier: GPL-2.0
# Copyright (c) 2000-2002 Silicon Graphics, Inc. All Rights Reserved.
#
# FS QA Test No. 015
#
# check out-of-space behaviour
#
seq=`basename $0`
seqres=$RESULT_DIR/$seq
echo "QA output created by $seq"
here=`pwd`
tmp=/tmp/$$
status=1 # success is the default!
# get standard environment, filters and checks
2013-03-15 12:28:04 +00:00
. ./common/rc
. ./common/filter
_cleanup()
{
2015-12-21 18:07:43 +11:00
_scratch_unmount
}
trap "_cleanup; exit \$status" 0 1 2 3 15
_free()
{
2001-05-14 23:31:15 +00:00
_df_dir $SCRATCH_MNT | $AWK_PROG '{ print $5 }'
}
# real QA test starts here
2011-08-01 12:31:19 +02:00
_supported_fs generic
_supported_os Linux
2004-06-15 07:32:36 +00:00
_require_scratch
_require_no_large_scratch_dev
# btrfs needs at least 256MB (with upward round off) to create a non-mixed mode
# fs. Ref: btrfs-progs: btrfs_min_dev_size()
_scratch_mkfs_sized $((256 * 1024 * 1024)) >> $seqres.full 2>&1 \
2011-08-01 12:31:19 +02:00
|| _fail "mkfs failed"
_scratch_mount
out=$SCRATCH_MNT/fillup.$$
rm -f $seqres.full
free0=`_free`
if [ -z "$free0" ]
then
echo " *** failed to get free space (0)"
exit 1
fi
echo "free space at start $free0" >> $seqres.full
echo "fill disk:" # well, filesystem really - not disk
POSIXLY_CORRECT=yes dd if=/dev/zero of=$out bs=1024k 2>&1 | _filter_dd
2001-05-14 23:31:15 +00:00
echo "check free space:"
free1=`_free`
if [ -z "$free1" ]
then
echo " *** failed to get free space (1)"
exit 1
fi
echo "free space after fill $free1" >> $seqres.full
2001-05-14 23:31:15 +00:00
if [ ! -e $out ]
then
echo " *** file not created"
exit 1
fi
if [ ! -s $out ]
then
echo " *** file created with zero length"
ls -l $out
exit 1
fi
echo "delete fill:"
if ! rm $out
then
echo " *** file not deleted"
exit 1
fi
if [ -e $out ]
then
echo " *** file still exists"
ls -l $out
exit 1
fi
echo "check free space:"
sync
2001-05-14 23:31:15 +00:00
free2=`_free`
if [ -z "$free2" ]
then
2001-05-14 23:31:15 +00:00
echo " *** failed to get free space (2)"
exit 1
fi
echo "free space after delete $free2" >> $seqres.full
echo -n " !!! "
2001-05-14 23:31:15 +00:00
_within_tolerance "free space" $free2 $free0 1% -v
status=0
exit